#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
PSP_MODULE_INFO("animetex", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
extern unsigned char anime_start[]; // テクスチャ参照
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
// 描画用Vertex構造体
typedef struct Vertex{
	unsigned short u, v;
	unsigned short color;
	short x, y, z;
}Vertex;
struct Vertex* vertices;

// キャラクタ情報用パラメータを定義
#define CHR_COUNT 4					// キャラクタ数
#define CHR_ANIME 4					// アニメフレーム最大値
short chr_x[]={20,60,20,60};		// キャラクタ描画X座標
short chr_y[]={20,20,60,60};		// キャラクタ描画Y座標
short chr_size[]={16,16,16,16};		// キャラクタサイズ(正方形想定)
unsigned short chr_u[]={0,0,0,0};	// テクスチャ参照ヨコ座標
unsigned short chr_v[]={0,16,32,48};// テクスチャ参照タテ座標
int chr_animeframe[]={0,0,0,0};		// 表示中のアニメフレーム格納用
long chr_animetiming[]={5,10,1,40};// アニメ速度(フレーム数/コマ)
long anime_timing=0;				// アニメーションタイミング

// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu設定一覧
	sceGuInit(); sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_4444, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x44000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuEnable(GU_TEXTURE_2D);
	// 設定完了
	sceGuFinish(); sceGuSync(0, GU_SYNC_FINISH);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	// ディスプレイリストからメモリ割り当て(CHR_COUNT利用)
	vertices = (struct Vertex*)sceGuGetMemory(2*CHR_COUNT* sizeof(struct Vertex));
	int i=0;
	while(1){
		sceGuStart(GU_DIRECT,list);
		// テクスチャデータのセット
		sceGuTexMode(GU_PSM_4444, 0, 0, GU_FALSE);
		sceGuTexImage(0, 64, 64, 64, anime_start);
		sceGuTexFunc(GU_TFX_REPLACE, GU_TCC_RGBA);
		sceGuTexFilter(GU_NEAREST, GU_NEAREST);
		for(i=0;i<CHR_COUNT;i++){ // キャラクタ数と同じ回数定義
			vertices[i*2  ].x = chr_x[i];
			vertices[i*2+1].x = chr_x[i]+chr_size[i];
			vertices[i*2  ].y = chr_y[i];
			vertices[i*2+1].y = chr_y[i]+chr_size[i];
			// アニメーション実装付きテクスチャパラメータ定義。
			anime_timing++; // アニメーションフレームを加算
			if(anime_timing%chr_animetiming[i]==0) chr_animeframe[i]++;
			if(chr_animeframe[i]>=CHR_ANIME) chr_animeframe[i]=0; // アニメループ
			vertices[i*2  ].u=chr_u[i]+chr_animeframe[i]*16;
			vertices[i*2+1].u=chr_u[i]+chr_size[i]+chr_animeframe[i]*16;
			vertices[i*2  ].v=chr_v[i];
			vertices[i*2+1].v=chr_v[i]+chr_size[i];
		}
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
